<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Document</title>
  <script src="https://unpkg.com/vue"></script>
</head>

<body>
  <div id="app">
    <template v-if="logado">
      <p>Usuário logado: {{ nome }}</p>
      <p>Perfil: Admin</p>
    </template>
    <p v-else-if="anonimo">Navegando como Anônimo</p>
    <p v-else>Nenhum usuário logado</p>
    <button @click="logado = !logado">
      {{ logado ? 'Sair' : 'Entrar' }}
    </button>
    <input type="checkbox" v-model="anonimo" id="anonimous">
    <label for="anonimous">Navegar como anônimo?</label>
    <hr>
    <!--
      - v-show é uma diretiva que também trabalha com a visibilidade de elementos e renderização condicional
      - mas não remove (ao contrário do v-if, v-else-if e v-else) o elemento da DOM da página gerada
      DOM
      - o DOM, um tipo de estrutura de dados da espécie árvore, é gerado pelo browser (em memória) a partir da interpretação do arquivo HTML (que tem elementos definidos em seu código).
      - por sua vez, manipulando-se a DOM, reflete-se no HTML interpretado pelo browser
      - os FWs, como o Vue, conseguem manipular a DOM.
      - uma das maneiras de manipulação da DOM pelos FWs é a renderização condicional de elementos HTML
      - o Vue tem 2 maneiras de manipular a renderização condicional de elementos (se condições lógicas forem cumpridas - ou não - ou passarem a serem cumpridas - ou não) na DOM do HTML, com as diretivas (atributos personalizados de elementos):
        - 'v-if' e/ou 'v-else-if' e/ou 'v-else' - excluindo ou inserindo elementos da DOM.
        - 'v-show' - aplicando estilo CSS (inline, direto no elemento), para ocultar ou exibir o elemento (através do estilo 'display: none'), mas sem retirá-lo da DOM.
      - as diferenças entre ambos métodos são:
        a) o custo de performance (processamento e tempo) em cada um com trechos de HTML grandes / consideráveis:
          - 'v-if' e demais: consome mais tempo do FW p/ ser gerado novamente
          - 'v-show': consome menos tempo do FW p/ ser gerado novamente
        b) em funcionalidades com aspecto de segurança vinculado:
          - exemplo: menu de sistema que só pode ser acessado por seu(ua) administrador(a).
          - 'v-if' e demais: é adequado
          - 'v-show': não é adequado
        c) em funcionalidades com aspectos opcionais de utilidade (tanto faz exibir ou não, e não é algo crítico se for exibido):
          - 'v-if' e demais: não é interessante
          - 'v-show': é interessante
        d) em funcionalidades que se alternam constantemente, por exemplo, a depender do estado da aplicação ou um componente:
          - 'v-if' e demais: não é interessante
          - 'v-show': é interessante
        e) outras condições ('else'):
          - 'v-if' e demais: tem
          - 'v-show': não tem
        f) estratégias para fazer múltiplas avaliações lógicas:
          - 'v-if' e demais:
            - negação lógica (v-if="!condicao")
            - outras avaliações lógicas - 'v-else-if' e/ou 'v-else' (v-else-if="condicao2" ou v-else como demais casos lógicos)
            - aninhamento lógico (<elem1 v-if="condicao"><elem2 v-if="condicao2"></elem2></elem1>)
          - 'v-show':
            - negação lógica (v-show="!condicao")
            - outras avaliações lógicas - não tem
            - aninhamento lógico (<elem1 v-show="condicao"><elem2 v-show="condicao2"></elem2></elem1>) - vide obs no item g abaixo
        g) possibilidade de usar aninhamento de elementos em elemento 'template':
          - 'v-if' e demais: sem problema
          - 'v-show': há problema (vide abaixo)
    -->
    <footer v-show="logado">
      Desenvolvido para você: usuário logado!
    </footer>
    <!--
      - quando se usa 'v-show', há um problema em usar-se template.
      - como o 'v-show' não remove elementos da DOM, em qualquer situação (true/false), seu interior será renderizado.
      - ou seja, mesmo que a condição especificada no template seja falsa, o interior do template (cumprindo sua função) será renderizado.
      - isso pode gerar exibições indesejáveis (pela avaliação lógica usada no template)
      - a solução, usando-se 'v-show', é não usar elemento 'template' para agrupar elementos-filhos e sim elemento 'div' (ou outro agrupador - de preferência semântico ou genérico como o 'div'), que terá sua exibição (e a de seus filhos) adequadamente tratada pelo vue
    -->
    <div v-show="!logado">
      <footer v-show="anonimo">Desenvolvido para você: usuário anônimo!</footer>
      <footer v-show="!anonimo">Desenvolvido para você: usuário deslogado!</footer>
    </div>
  </div>
  <script src="app.js"></script>
</body>

</html>